\documentclass{article}
\usepackage{epsfig}

\begin{document}

\section{\tt PSDEstimate<T>}

{\tt PSDEstimate<T>} is a template abstract base class for 
power spectrum estimation.

\subsection{User Interface}

The following is a list of public functions declared in 
{\tt PSDEstimate.hh}:

{\footnotesize 
\begin{verbatim}
  enum detrendFlag { none   = 0,
                     mean   = 1,
                     linear = 2 };

  template<class T>
  class PSDEstimate {

  public:

    // destructor
    virtual ~PSDEstimate();

    // default constructor
    PSDEstimate(const detrendFlag dFlag = none);

    // copy constructor
    PSDEstimate(const PSDEstimate<T>& r);

    // copy assignment
    const PSDEstimate<T>& operator=(const PSDEstimate<T>& r);

    // set parameters
    void set_dFlag(const detrendFlag& dFlag);

    // accessors
    //
    virtual string what() const = 0;
    detrendFlag dFlag() const;
    
    // operations
    //
    virtual void apply(valarray<T>&       psd,
                       valarray<T>&       freqs,
                       const valarray<T>& in)
      throw (std::invalid_argument) = 0;

    virtual void apply(valarray<T>&                 psd,
                       valarray<T>&                 freqs,
                       const valarray<complex<T> >& in)
      throw (std::invalid_argument) = 0;

    virtual void operator()(valarray<T>&       psd,
                            valarray<T>&       freqs,
                            const valarray<T>& in)
      throw (std::invalid_argument) = 0;

    virtual void operator()(valarray<T>&                 psd,
                            valarray<T>&                 freqs,
                            const valarray<complex<T> >& in)
      throw (std::invalid_argument) = 0;

  };
\end{verbatim}}

\subsection{Description}

{\tt PSDEstimate<T>} is a template abstract base class for 
power spectrum estimation.
Currently, {\tt WelchEstimate<T>} is the only concrete
class which derives from {\tt PSDEstimate<T>}, estimating
power spectra by averaging modified periodograms for 
overlapping segments of data \cite{PSDP&W}.
(See {\tt WelchEstimate<T>} for details.)
Additional concrete power spectrum estimation classes 
(representing, e.g., multitaper estimation \cite{PSDP&W}) 
may be added in the future.
The template class {\tt T} should be either {\tt float} or
{\tt double}.
If you need to estimate the power spectrum of integer data,
you should first cast the data to either {\tt float} or 
{\tt double}.

Since {\tt PSDEstimate<T>} is an abstract base class, one 
cannot instantiate a {\tt PSDEstimate<T>} object.
However, pointers and references to {\tt PSDEstimate<T>} 
are valid.
The {\tt what}, {\tt apply} and {\tt operator()} methods are 
pure virtual.
They are defined in the derived class {\tt WelchEstimate<T>}.
The set and accessor methods {\tt set\_dFlag} and {\tt dFlag} 
are defined in {\tt PSDEstimate<T>}.
They allow the user to set and/or determine the current value
of a {\tt detrendFlag} variable, which is an {\tt enum} type 
specifying if a mean and/or linear trend should be removed from 
the data before estimating its power spectrum.

\subsection{Operating Instructions}

\subsubsection{Example Usage}

See {\tt WelchEstimate<T>}.

\subsubsection{Options/Defaults}

The default constructor {\tt PSDEstimate<T>} sets the 
{\tt detrendFlag} variable to {\tt none} (i.e., no detrending 
is performed before estimating the power spectrum).

\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

The only standard exception that {\tt PSDEstimate<T>} throws is 
{\tt invalid\_argument}.  
See {\tt WelchEstimate<T>} for details.

\subsubsection{Exceptions Caught}

None.

\subsection{Algorithms}

Not applicable.

\subsection{Accuracy}

The accuracy of the {\tt apply} and {\tt operator()} methods is 
determined by the template type {\tt T}:
If {\tt T} is {\tt float}, the accuracy is single precision.
If {\tt T} is {\tt double}, the accuracy is double precision.

\subsection{Performance}

Performance statistics for power spectrum estimation will be 
generated during the datacondAPI Mock Data Challenge.
See {\tt WelchEstimate<T>} for details.

\subsection{Testing}

{\tt PSDEstimate<T>} was tested with {\tt WelchEstimate<T>} 
by the code contained in {\tt tPSDEstimate.cc}.
See {\tt WelchEstimate<T>} for details.

\subsection{Notes}

None.

\subsection{See Also}

\begin{itemize}
\item 
{\tt class WelchEstimate<T>}
\end{itemize}

\begin{thebibliography}{99}

\bibitem{PSDP&W}
D.B.\ Percival and A.T.\ Walden,
{\em Spectral Analysis for Physical Applications\/},
(Cambridge, Cambridge, 1993).

\end{thebibliography}

\end{document}

